#include <xen/config.h>
#include <xen/bitops.h>

int __find_next_bit(const void *addr, unsigned long size, unsigned long offset)
{
    unsigned long *p = ((unsigned long *) addr) + (offset >> 6);
    unsigned long result = offset & ~63UL;
    unsigned long tmp;

    if (offset >= size)
        return size;
    size -= result;
    offset &= 63UL;
    if (offset) {
        tmp = *(p++);
        tmp &= ~0UL << offset;
        if (size < 64)
            goto found_first;
        if (tmp)
            goto found_middle;
        size -= 64;
        result += 64;
    }
    while (size & ~63UL) {
        if ((tmp = *(p++)))
            goto found_middle;
        result += 64;
        size -= 64;
    }
    if (!size)
        return result;
    tmp = *p;
found_first:
    tmp &= ~0UL >> (64-size);
    if (tmp == 0UL)     /* Are any bits set? */
        return result + size; /* Nope. */
found_middle:
    return result + __ffs(tmp);
}
