#ifndef __ASM_FDTMACROS_H
#define __ASM_FDTMACROS_H

enum {
        PROP_STR,
        PROP_INT32
};

static inline int get_fdt_prop(const char* node_path, 
						const char *prop, void *prop_buf, int type)
{
	int prop_len;
	const void *pbuf;
	int node;

	node = fdt_path_offset(fdt, node_path);
	if (node < 0)
		return -1;

	pbuf = (char *)fdt_getprop(fdt, node, prop, &prop_len);
	if (pbuf == NULL)
		return -1;

	memcpy((void *) prop_buf, (void * )pbuf, prop_len);

	return 0;
}

#define FDT_GET_ATTRIB(path, prop, prop_buf) \
do { \
	if (get_fdt_prop(path, prop, prop_buf, PROP_INT32) != 0) {	\
		printk("Get prop failed on %s\n", path); \
        return -EINVAL; \
	} \
} while (0)

#define FDT_GET_ATTRIB_STR(path, prop, prop_buf) \
do { \
    if (get_fdt_prop(path, prop, prop_buf, PROP_STR) != 0) { \
        printk("Failed to parse %s! Aborting !\n", prop); \
        return -EINVAL; \
    } \
} while (0)

#endif
