#ifndef _ASM_MAPOPS_H
#define _ASM_MAPOPS_H

#include <xen/config.h>
#include <asm/bootinfo.h>

extern struct addrmap *merge_maps(struct addrmap *map1, struct addrmap *map2, struct addrmap *scratch);
extern struct addrmap *subtract_map(struct addrmap *from, struct addrmap *delete, struct addrmap *scratch);
extern void coalesce_map(struct addrmap *map);
extern void sort_map(struct addrmap *map);

extern void print_map(struct addrmap *addrmap);
extern void delete_map(struct addrmap *addrmap);

extern int serialize_map(char *dst, struct addrmap *addrmap);
extern int deserialize_map(char *dst, struct addrmap *addrmap);

extern int serialize_strings(char *dst, char **s);
extern int deserialize_strings(char **dst, char *src);

extern int add_addrmap_entry(struct addrmap *memmap, uint64_t addr, uint64_t size, uint32_t type);

#endif
